"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var lodash_1 = require("lodash");
var react_2 = require("react-cosmos-shared2/react");
var ErrorCatch = /** @class */ (function (_super) {
    __extends(ErrorCatch, _super);
    function ErrorCatch() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            error: null
        };
        return _this;
    }
    ErrorCatch.prototype.componentDidCatch = function (error, info) {
        this.setState({
            error: error.message + "\n" + info.componentStack
        });
    };
    ErrorCatch.prototype.componentDidUpdate = function (prevProps) {
        // A change in fixture (children) or fixture state signifies that the
        // problem that caused the current error might've been solved. If the error
        // persists, it will organically trigger the error state again in the next
        // update
        if (this.state.error &&
            (fixtureChanged(this.props.children, prevProps.children) ||
                fixtureStateChanged(this.props.fixtureState, prevProps.fixtureState))) {
            this.setState({ error: null });
            this.props.onErrorReset();
        }
    };
    ErrorCatch.prototype.render = function () {
        return this.state.error
            ? this.renderError(this.state.error)
            : this.props.children;
    };
    ErrorCatch.prototype.renderError = function (error) {
        // NOTE: In dev mode this output is overlayed by react-error-overlay,
        // which has greater UI and detail. But the information rendered here is
        // most useful in static exports, where react-error-overlay is missing.
        return (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement("p", null,
                react_1.default.createElement("strong", null, "Ouch, something wrong!")),
            react_1.default.createElement("pre", null, error),
            react_1.default.createElement("p", null, "Check console for more info.")));
    };
    return ErrorCatch;
}(react_1.default.Component));
exports.ErrorCatch = ErrorCatch;
function fixtureChanged(f1, f2) {
    return !react_2.areNodesEqual(f1, f2);
}
function fixtureStateChanged(fS1, fS2) {
    return !lodash_1.isEqual(fS1, fS2);
}
