"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var util_1 = require("react-cosmos-shared2/util");
exports.rendererId = getRendererId();
// Renderer ID is remembered to avoid announcing a new renderer when reloading
// the renderer window. Note that each tab has creates a new session and thus
// a new rendererId.
// https://developer.mozilla.org/en-US/docs/Web/API/Window/sessionStorage
function getRendererId() {
    var rId = sessionStorage.getItem('cosmosRendererId');
    if (!rId) {
        rId = util_1.uuid();
        sessionStorage.setItem('cosmosRendererId', rId);
    }
    return rId;
}
