"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var debug_1 = __importDefault(require("debug"));
var socket_io_1 = __importDefault(require("socket.io"));
var build_1 = require("react-cosmos-shared2/build");
var renderer_1 = require("react-cosmos-shared2/renderer");
var d = debug_1.default('cosmos:message');
function createMessageHandler(httpServer) {
    d('init');
    var io = socket_io_1.default(httpServer);
    io.on('connection', function (socket) {
        d('connection');
        // Forward commands between connected clients. Parties involved can be the
        // - The Cosmos UI, which acts as a remote control
        // - The web iframe or the React Native component renderers
        socket.on(renderer_1.RENDERER_MESSAGE_EVENT_NAME, function (msg) {
            d('on renderer message %o', msg);
            socket.broadcast.emit(renderer_1.RENDERER_MESSAGE_EVENT_NAME, msg);
        });
    });
    function sendMessage(msg) {
        d('send server message %o', msg);
        io.emit(build_1.SERVER_MESSAGE_EVENT_NAME, msg);
    }
    function cleanUp() {
        var sockets = io.sockets.sockets;
        Object.keys(sockets).forEach(function (id) {
            sockets[id].disconnect(true);
        });
    }
    return { sendMessage: sendMessage, cleanUp: cleanUp };
}
exports.createMessageHandler = createMessageHandler;
